#ifndef STATIC_CONTAINER_COMPARE_METHODS_H

#define STATIC_CONTAINER_COMPARE_METHODS_H

#include <algorithm>
#include <boost/operators.hpp>

namespace static_container {
	///	rZq` mixin
	template < typename SubClass >
	class compare_methods : public boost::less_than_comparable1< SubClass >, public boost::equality_comparable1< SubClass > {
	public:
		//	VC 7.1 ł͂ɂ list ܂舵ĂȂ
/*		friend bool operator == ( const SubClass& a, const SubClass& b ) {
			return a.equal( b );
		}
		
		friend bool operator < ( const SubClass& a, const SubClass& b ) {
			return std::lexicographical_compare( a.begin(), a.end(), b.begin(), b.end() );
		}*/
		
		bool operator == ( const SubClass& other ) const {
			return equal( other );
		}
		
		bool operator < ( const SubClass& other ) const {
			return std::lexicographical_compare(
				static_cast< const SubClass* >( this )->begin(), static_cast< const SubClass* >( this )->end(),
				other.begin(), other.end() );
		}
		
		///	CӃReiƂ̔r
		template < typename OtherContainer >
		bool equal( const OtherContainer& cont ) const {
			if ( static_cast< const SubClass* >( this )->size() == cont.size() ) {
				return std::equal(
					static_cast< const SubClass* >( this )->begin(),
					static_cast< const SubClass* >( this )->end(),
					cont.begin() );
			} else {
				return false;
			}
		}
	};
}

#endif
