#ifndef STATIC_CONTAINER_CONTAINER_DESTRUCT_H

#define STATIC_CONTAINER_CONTAINER_DESTRUCT_H

#include <boost/type_traits/is_pod.hpp>
#include <boost/mpl/if.hpp>

namespace static_container {
	namespace detail {
		template < typename T >
		struct destructor_caller {
			static void call( T& t ) {
				t.~T();
			}
		};

		template < typename T >
		struct through {
			static void call( T& t ) {}
		};
	}
	
	///	T fXgN^ĂԕKv̂NXłꍇ̂݃fXgN^Ă
	template < typename T >
	void destruct( T& t ) {
		boost::mpl::if_<
			boost::is_POD< T >,
			detail::through< T >,
			detail::destructor_caller< T > >::type::call( t );
	}
}

#endif