#ifndef STATIC_CONTAINER_LIST_NODE_POOL_H

#define STATIC_CONTAINER_LIST_NODE_POOL_H

#include <boost/noncopyable.hpp>
#include "static_container/list_node.h"
#include "static_container/STATIC_CONTAINER_MEMBERTYPEDEF.h"

namespace static_container {
	///	ListNode pv[ۃNX
	/**
	 *	TuNX̓RXgN^ init() Ă΂Ȃ΂ȂȂB
	 */
	template < typename Value >
	class abstruct_list_node_pool : boost::noncopyable {
	public:
		typedef list_link			link;
		typedef list_node< Value >	node;
		STATIC_CONTAINER_MEMBERTYPEDEF( Value )
	private:
		link	free_;
		
	protected:
		abstruct_list_node_pool() {
		}
		virtual node*	getTop() = 0;

		void	init() {
			//	ׂĂ̗vf free_ ɒǉ
			node* top = getTop();
			free_.next = top;
			free_.prev = top + size() - 1;
			top->prev = &free_;
			free_.prev->next = &free_;
			for ( size_type i = 1; i < size(); ++i ) {
				top[ i - 1 ].next = &top[ i ];
				top[ i ].prev = &top[ i - 1 ];
			}
		}
	public:
		virtual size_type size() const = 0;

		///	̈̑ݗ^̂݁Bvalue ̃RXgN^ĂяóA[U[̐ӔCB
		node* allocate() {
			if ( free_.next != &free_ ) {
				node* result = static_cast< node* >( free_.next );
				result->isolate();
				return result;
			} else {
				return 0;
			}
		}

		///	[ first, last )  free_ ̏I[ɐڑ
		/**
		 *	fXgN^Ăяo͍sȂ
		 */
		void	deallocate( link* first, link* last ) {
			if ( first == last ) {
				return;
			}
			
			//	ufirst ̒OvƁulastvڑ
			first->prev->next = last;
			link* lastPrev = last->prev;
			last->prev = first->prev;

			//	[ first, lastPrev ]  free_ ̏I[ɐڑ
			first->prev = free_.prev;
			free_.prev->next = first;
			free_.prev = lastPrev;
			lastPrev->next = &free_;
		}

		///	n  free_ ̏I[ɐڑ
		/**
		 *	fXgN^Ăяo͍sȂ
		 */
		void	deallocate( link* n ) {
			deallocate( n, n->next );
		}

		///	^?
		/**
		 *	@retval	true	ȏ}s\
		 *	@retval	false	}\
		 */
		bool full() const {
			return free_.next == &free_;
		}

		///	󂫃m[h擾
		size_type rest() const {
			link* n = free_.next;
			size_type result = 0;
			while ( &free_ != n ) {
				n = n->next;
				++result;
			}
			return result;
		}
	};

	///	ListNode pv[
	template < typename Value, uint_fast_t Size >
	class list_node_pool : public abstruct_list_node_pool< Value > {
		uintptr_t		buffer_[ Size * sizeof( node ) / sizeof( uintptr_t ) ];
		virtual node*	getTop() {
			return reinterpret_cast< node* >( buffer_ );
		}
	public:
		list_node_pool() {
			init();
		}

		virtual size_type size() const {
			return Size;
		}
	};
}

#endif