#include "static_container/test/assert_new.h"
#include <boost/test/minimal.hpp>
#include "static_container/list.h"
#include "static_container/test/basic_sequence.h"
#include <iterator>
#include <boost/iterator/counting_iterator.hpp>

using namespace static_container;

struct listgen {
	template < typename Value, size_type Size >
	struct gen {
		typedef list< Value, Size >	type;
	};
};

void test_lodge_list() {
	list_node_pool< int, 10 >	pool;
	lodge_list< int >	list0( pool );
	lodge_list< int >	list1( pool );
	lodge_list< int >	list2( pool );
	
	BOOST_REQUIRE( 10 == pool.rest() );
	BOOST_REQUIRE( list0.empty() );
	list0.push_back( 100 );
	BOOST_REQUIRE( 1 == list0.size() );
	BOOST_REQUIRE( 9 == pool.rest() );
	BOOST_REQUIRE( 100 == list0.front() );
	
	list1.push_back( 10 );
	list2.push_back( 5 );
	list0.push_back( 9 );
	BOOST_REQUIRE( 6 == pool.rest() );
	list1.pop_back();
	BOOST_REQUIRE( 7 == pool.rest() );
	
	//	NẤAlist0 ̂
	list0.clear();
	BOOST_REQUIRE( list0.empty() );
	BOOST_REQUIRE( 9 == pool.rest() );	// ̃XgLm[h͂܂ԋpĂȂ
	
	std::copy( boost::counting_iterator< int >( 0 ), boost::counting_iterator< int >( pool.rest() ), std::back_inserter( list1 ) );
	BOOST_REQUIRE( 0 == pool.rest() );
	
	BOOST_REQUIRE( list1.end() != std::find( list1.begin(), list1.end(), 5 ) );
	lodge_list< int >::iterator it = list1.begin();
	std::advance( it, 5 );
	list1.erase( it );
	BOOST_REQUIRE( list1.end() == std::find( list1.begin(), list1.end(), 5 ) );
}

int test_main( int argc, char* argv[] ) {
	test::begin(); // new Ăяoɓ{苶I
	test::basic_sequence< listgen >();
	test_lodge_list();
	return 0;
}